﻿Imports System.Text
Imports Microsoft.VisualStudio.TestTools.UnitTesting

Public Class Prgm

    Private cs As CalcState
    Private c As Calculator

    '  A,  B,  C,  D,  E,  F, 7,  8,  9, 10
    ' 21, 22, 23, 24, 25, 26, 4,  5,  6, 20
    ' 31, 32, 33, 35, 35, 36, 1,  2,  3, 30
    ' 41, 42, 43, 44, 45,     0, 48, 49, 40

    Private Const KeyA As Integer = 10
    Private Const KeyB As Integer = 11
    Private Const KeyC As Integer = 12
    Private Const KeyD As Integer = 13
    Private Const KeyE As Integer = 14
    Private Const KeyF As Integer = 15
    Private Const Key7 As Integer = 7
    Private Const Key8 As Integer = 8
    Private Const Key9 As Integer = 9
    Private Const KeyDiv As Integer = 16
    Private Const KeyGSB As Integer = 33
    Private Const KeyGTO As Integer = 34
    Private Const KeyHEX As Integer = 35
    Private Const KeyDEC As Integer = 36
    Private Const KeyOCT As Integer = 37
    Private Const KeyBIN As Integer = 38
    Private Const Key4 As Integer = 4
    Private Const Key5 As Integer = 5
    Private Const Key6 As Integer = 6
    Private Const KeyMul As Integer = 32
    Private Const KeyRS As Integer = 49
    Private Const KeySST As Integer = 50
    Private Const KeyRol As Integer = 51
    Private Const KeyXY As Integer = 52
    Private Const KeyBSP As Integer = 53
    Private Const KeyEnt As Integer = 54
    Private Const Key1 As Integer = 1
    Private Const Key2 As Integer = 2
    Private Const Key3 As Integer = 3
    Private Const KeyMin As Integer = 48
    Private Const KeyON As Integer = 65
    Private Const KeyFKey As Integer = 66
    Private Const KeyGKey As Integer = 67
    Private Const KeySTO As Integer = 68
    Private Const KeyRCL As Integer = 69
    Private Const Key0 As Integer = 0
    Private Const KeyDp As Integer = 72
    Private Const KeyCHS As Integer = 73
    Private Const KeyAdd As Integer = 64

    Public Sub New(ByVal cs1 As CalcState, ByVal c1 As Calculator)
        MyBase.New
        cs = cs1
        c = c1
    End Sub

    Public Sub simpleProgram()
        Dim dp As DisplayPacket
        dp = c.ProcessKey(-1)
        If Not dp.Prgm_Annunciator Then
            c.ProcessKey(KeyGKey)
            c.ProcessKey(KeyRS)      ' enter PGRM mode
        End If

        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyRol)         ' clear the program

        c.ProcessKey(1)              '                        001
        c.ProcessKey(0)              ' put a 10 in x          002

        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyGTO)         ' swap with I            003

        c.ProcessKey(5)              ' put a 5 in Reg 0       004
        c.ProcessKey(KeySTO)
        c.ProcessKey(0)              '                        005

        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyGTO)
        c.ProcessKey(KeyA)           ' build label A          006

        c.ProcessKey(KeyGSB)
        c.ProcessKey(KeyB)           ' call subroutine B      007

        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyXY)          ' pause                  008

        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyHEX)         ' DSZ                    009

        c.ProcessKey(KeyGTO)
        c.ProcessKey(KeyA)           ' Goto A                 010

        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyGSB)         ' return                 011

        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyGTO)
        c.ProcessKey(KeyB)           ' build Label B          012

        c.ProcessKey(KeyRCL)
        c.ProcessKey(0)              ' get what's in Reg 0    013

        c.ProcessKey(1)              '                        014

        c.ProcessKey(KeyAdd)         ' add one...             015

        c.ProcessKey(KeySTO)
        c.ProcessKey(0)              ' store it back          016

        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyGSB)         ' return                 017

        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyRS)          ' exit PGRM mode
    End Sub

    Public Sub run()
        cs.PrgmRunning = True

        While (cs.PrgmPosition < cs.PrgmMemory.Count)
            ' execute the instructions
            If RunLine() Then
                ' Some error occurred
                Exit While
            End If

            ' prepare to process the next line
            cs.PrgmPosition = (cs.PrgmPosition + 1)
            ' stop if somebody pressed a key
            If Not cs.PrgmRunning Then
                Exit While
            End If

        End While

        ' v6.0.7 - 22 Jul 2015
        'ProcessPacket(c.ProcessKey(-1));
    End Sub

    Private Function RunLine() As Boolean
        Dim line As String
        Dim k3 As Integer
        Dim k1 As Integer
        Dim k2 As Integer
        Dim p As DisplayPacket
        ' A quick sanity check
        ' v6.0.2 - 26 Apr 12
        If ((cs.PrgmPosition < 0) OrElse (cs.PrgmPosition >= cs.PrgmMemory.Count)) Then
            ' if you "step off the edge", then just stop
            Return True
        End If

        ' Go to the current line and process the keys found there.
        ' The line will be in 1 of 3 formats
        line = cs.PrgmMemory(cs.PrgmPosition)
        If line.StartsWith("      ") Then
            Try
                k1 = Integer.Parse(line.Substring(6, 2), System.Globalization.NumberStyles.HexNumber)
                p = c.ProcessKey(k1)
            Catch e As System.Exception
                ' I'm anticipating that folks might edit the XML by hand
                ' to make minor tweaks to a program.  So, we have to be
                ' ready for a corrupted file
                'MessageBox.Show("Corrupted Program Memory at line " + cs.PrgmPosition, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Return True
            End Try

        ElseIf line.StartsWith("   ") Then
            Try
                ' special case for STO and RCL that optionally use the "." prefix
                If (line(6) = Microsoft.VisualBasic.ChrW(46)) Then
                    k1 = Integer.Parse(line.Substring(3, 2), System.Globalization.NumberStyles.HexNumber)
                    k2 = Integer.Parse(line.Substring(7, 1), System.Globalization.NumberStyles.HexNumber)
                    c.ProcessKey(k1)
                    c.ProcessKey(CType(Calculator.k.KeyDp, Integer))
                    p = c.ProcessKey(k2)
                Else
                    k1 = Integer.Parse(line.Substring(3, 2), System.Globalization.NumberStyles.HexNumber)
                    k2 = Integer.Parse(line.Substring(6, 2), System.Globalization.NumberStyles.HexNumber)
                    c.ProcessKey(k1)
                    p = c.ProcessKey(k2)
                End If

            Catch e As System.Exception
                'MessageBox.Show("Corrupted Program Memory at line " + cs.PrgmPosition, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Return True
            End Try

        Else
            Try
                k1 = Integer.Parse(line.Substring(0, 2), System.Globalization.NumberStyles.HexNumber)
                k2 = Integer.Parse(line.Substring(3, 2), System.Globalization.NumberStyles.HexNumber)
                k3 = Integer.Parse(line.Substring(6, 2), System.Globalization.NumberStyles.HexNumber)
                c.ProcessKey(k1)
                c.ProcessKey(k2)
                p = c.ProcessKey(k3)
            Catch e As System.Exception
                'MessageBox.Show("Corrupted Program Memory at line " + cs.PrgmPosition, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Return True
            End Try

        End If

        ' We only update the display if there is a pause.  No Annunciator
        ' flags are updated while a program is running.
        'If p.Delay > 0 Then
        '    If p.AlternateText = String.Empty Then
        '        SetDisplayText(p.DisplayText)
        '        Application.DoEvents()
        '        Threading.Thread.Sleep(p.Delay)
        '    Else
        '        SetDisplayText(p.AlternateText)
        '        Application.DoEvents()
        '        Threading.Thread.Sleep(p.Delay)
        '        SetDisplayText(p.DisplayText)
        '    End If
        'End If
        Return False
    End Function
End Class