﻿Imports System.Text
Imports Microsoft.VisualStudio.TestTools.UnitTesting

<TestClass()>
Public Class Row2

    Private cs As CalcState
    Private c As Calculator
    Private p As Prgm

    '  A,  B,  C,  D,  E,  F, 7,  8,  9, 10
    ' 21, 22, 23, 24, 25, 26, 4,  5,  6, 20
    ' 31, 32, 33, 35, 35, 36, 1,  2,  3, 30
    ' 41, 42, 43, 44, 45,     0, 48, 49, 40

    Private Const KeyA As Integer = 10
    Private Const KeyB As Integer = 11
    Private Const KeyC As Integer = 12
    Private Const KeyD As Integer = 13
    Private Const KeyE As Integer = 14
    Private Const KeyF As Integer = 15
    Private Const Key7 As Integer = 7
    Private Const Key8 As Integer = 8
    Private Const Key9 As Integer = 9
    Private Const KeyDiv As Integer = 16
    Private Const KeyGSB As Integer = 33
    Private Const KeyGTO As Integer = 34
    Private Const KeyHEX As Integer = 35
    Private Const KeyDEC As Integer = 36
    Private Const KeyOCT As Integer = 37
    Private Const KeyBIN As Integer = 38
    Private Const Key4 As Integer = 4
    Private Const Key5 As Integer = 5
    Private Const Key6 As Integer = 6
    Private Const KeyMul As Integer = 32
    Private Const KeyRS As Integer = 49
    Private Const KeySST As Integer = 50
    Private Const KeyRol As Integer = 51
    Private Const KeyXY As Integer = 52
    Private Const KeyBSP As Integer = 53
    Private Const KeyEnt As Integer = 54
    Private Const Key1 As Integer = 1
    Private Const Key2 As Integer = 2
    Private Const Key3 As Integer = 3
    Private Const KeyMin As Integer = 48
    Private Const KeyON As Integer = 65
    Private Const KeyFKey As Integer = 66
    Private Const KeyGKey As Integer = 67
    Private Const KeySTO As Integer = 68
    Private Const KeyRCL As Integer = 69
    Private Const Key0 As Integer = 0
    Private Const KeyDp As Integer = 72
    Private Const KeyCHS As Integer = 73
    Private Const KeyAdd As Integer = 64

    Public Sub New()
        MyBase.New
        cs = New CalcState
        c = New Calculator(cs)
        p = New Prgm(cs, c)
    End Sub

    <TestMethod()>
    Public Sub row2Yellow()

        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)

        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)

        '
        ' Round 1... using positive numbers And 1's complement
        '

        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        c.ProcessKey(5)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySST)        ' store 5 in Reg index
        c.ProcessKey(3)
        c.ProcessKey(KeySTO)
        c.ProcessKey(5)             ' put a 3 in Reg 5
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyGSB)        ' x:(i)
        c.ProcessKey(KeyRCL)
        dp = c.ProcessKey(5)
        Assert.AreEqual("3 d", dp.DisplayText)
        c.ProcessKey(KeyRCL)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeySST)   ' I
        Assert.AreEqual("5 d", dp.DisplayText)

        c.ProcessKey(5)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySST)        ' store 5 in Reg index
        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyGTO)        ' x:I
        Assert.AreEqual("5 d", dp.DisplayText)
        c.ProcessKey(KeyRCL)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeySST)   ' x:I
        Assert.AreEqual("3 d", dp.DisplayText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(4)
        c.ProcessKey(3)        ' enable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyHEX)    ' Show HEX
        Assert.AreEqual("0011 h", dp.AlternateText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(5)
        c.ProcessKey(3)
        ' disable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyHEX)    ' Show HEX
        Assert.AreEqual("11 h", dp.AlternateText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(4)
        c.ProcessKey(3)
        ' enable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyDEC)    ' Show DEC
        Assert.AreEqual("17 d", dp.AlternateText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(5)
        c.ProcessKey(3)
        ' disable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyDEC)    ' Show DEC
        Assert.AreEqual("17 d", dp.AlternateText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(4)
        c.ProcessKey(3)
        ' enable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyOCT)    ' Show OCT
        Assert.AreEqual("000021 o", dp.AlternateText)
        c.ProcessKey(KeyGKey)
        c.ProcessKey(5)
        c.ProcessKey(3)

        ' disable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyOCT)    ' Show OCT
        Assert.AreEqual("21 o", dp.AlternateText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(4)
        c.ProcessKey(3)
        ' enable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyBIN)    ' Show BIN
        Assert.AreEqual("00000000 00010001 b", dp.AlternateText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(5)
        c.ProcessKey(3)
        ' disable leading zeros
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyBIN)    ' Show BIN
        Assert.AreEqual("10001 b", dp.AlternateText)

        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(4)
        ' bit 4
        c.ProcessKey(KeyFKey)
        c.ProcessKey(4)
        Assert.AreEqual("17 d", dp.DisplayText)

        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        ' bit 5
        c.ProcessKey(KeyFKey)
        c.ProcessKey(4)     ' SB
        Assert.AreEqual("49 d", dp.DisplayText)

        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(4)
        ' bit 4
        c.ProcessKey(KeyFKey)
        c.ProcessKey(5)     ' CB
        Assert.AreEqual("1 d", dp.DisplayText)

        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        ' bit 5
        c.ProcessKey(KeyFKey)
        c.ProcessKey(5)     ' CB
        Assert.AreEqual("17 d", dp.DisplayText)

        ' test programming functions via the Program Position (increment on false)
        cs.PrgmPosition = 0
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(4)
        ' bit 4
        c.ProcessKey(KeyFKey)
        c.ProcessKey(6)     ' B?
        Assert.AreEqual(0, cs.PrgmPosition)

        cs.PrgmPosition = 0
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(7)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        ' bit 5
        c.ProcessKey(KeyFKey)
        c.ProcessKey(6)     ' B?
        Assert.AreEqual(1, cs.PrgmPosition)

        c.ProcessKey(4)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyMul)   ' AND
        Assert.AreEqual("0 d", dp.DisplayText)

        c.ProcessKey(4)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyMul)   ' AND
        Assert.AreEqual("4 d", dp.DisplayText)

        c.ProcessKey(4)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyMul)   ' AND
        Assert.AreEqual("3 d", dp.DisplayText)

        ' negative numbers
        c.ProcessKey(4)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        ' swapped
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyMul)   ' AND
        Assert.AreEqual("4 d", dp.DisplayText)

        ' 2's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(2)
        c.ProcessKey(4)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyMul)   ' AND
        Assert.AreEqual("0 d", dp.DisplayText)

        ' negative numbers
        c.ProcessKey(4)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyCHS)
        ' swapped
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyMul)   ' AND
        Assert.AreEqual("4 d", dp.DisplayText)
    End Sub

    <TestMethod()>
    Public Sub row2Blue()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)

        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        ' Run the "simple program" to test GSB, GTO, RTN, LBL, PSE, DSZ, etc
        p.simpleProgram()
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyRol)
        ' reset to 000
        p.run()
        dp = c.ProcessKey(-1)   ' PRGM
        Assert.AreEqual("15 d", dp.DisplayText)

        cs.PrgmPosition = 5
        c.ProcessKey(2)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyGTO)
        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyDEC)    ' ISZ
        Assert.AreEqual(5, cs.PrgmPosition)
        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyDEC)    ' ISZ
        Assert.AreEqual(6, cs.PrgmPosition)
        c.ProcessKey(KeyGKey)
        c.ProcessKey(KeyDEC)    ' ISZ
        Assert.AreEqual(6, cs.PrgmPosition)

        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyOCT)   ' SQRT
        Assert.AreEqual("2 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(5)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyOCT)   ' SQRT
        Assert.AreEqual("Error 0 - Improper Math Operation", dp.AlternateText)
        Assert.AreEqual(True, dp.Carry_Annunciator)

        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyBIN)   ' 1/x just ignored...
        Assert.AreEqual("5 d", dp.DisplayText)

        c.ProcessKey(KeyGKey)
        c.ProcessKey(4)
        dp = c.ProcessKey(0)    ' SF
        Assert.AreEqual(True, cs.Flags(CType(CalcState.CalcFlag.User0, Integer)))

        c.ProcessKey(KeyGKey)
        c.ProcessKey(5)
        dp = c.ProcessKey(0)    ' CF
        Assert.AreEqual(False, cs.Flags(CType(CalcState.CalcFlag.User0, Integer)))
        cs.PrgmPosition = 5
        c.ProcessKey(KeyGKey)
        c.ProcessKey(6)
        dp = c.ProcessKey(0)
        Assert.AreEqual(6, cs.PrgmPosition)

        cs.PrgmPosition = 5
        c.ProcessKey(KeyGKey)
        c.ProcessKey(4)
        c.ProcessKey(0)
        ' set it again..
        c.ProcessKey(KeyGKey)
        c.ProcessKey(6)
        dp = c.ProcessKey(0)    ' F?
        ' did not advance = true
        Assert.AreEqual(5, cs.PrgmPosition)

        ' 1's comp
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        c.ProcessKey(3)
        c.ProcessKey(2)
        c.ProcessKey(0)
        c.ProcessKey(0)
        c.ProcessKey(0)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(5)        ' 32000 x 15 = 480000
        dp = c.ProcessKey(KeyMul)   ' Mul
        Assert.AreEqual("21248 d", dp.DisplayText)
        Assert.AreEqual(True, dp.Overflow_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(2)
        c.ProcessKey(0)
        c.ProcessKey(0)
        c.ProcessKey(0)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(5)        ' 32000 x 15 = 480000
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyMul)    ' DBL*
        Assert.AreEqual("7 d", dp.DisplayText)
        c.ProcessKey(KeyRol)
        Assert.AreEqual("21248 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Overflow_Annunciator)

        c.ProcessKey(3)
        c.ProcessKey(2)
        c.ProcessKey(0)
        c.ProcessKey(0)
        c.ProcessKey(0)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(1)
        c.ProcessKey(5)        ' -32000 x 15 = -480000
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyMul)    ' DBL *
        Assert.AreEqual("-7 d", dp.DisplayText)
        c.ProcessKey(KeyRol)
        Assert.AreEqual("-21248 d", dp.DisplayText)
        Assert.AreEqual(False, dp.Overflow_Annunciator)
    End Sub
End Class