﻿Imports System.Text
Imports Microsoft.VisualStudio.TestTools.UnitTesting


<TestClass()>
Public Class Row4

    Private cs As CalcState
    Private c As Calculator
    Private p As Prgm

    '  A,  B,  C,  D,  E,  F, 7,  8,  9, 10
    ' 21, 22, 23, 24, 25, 26, 4,  5,  6, 20
    ' 31, 32, 33, 35, 35, 36, 1,  2,  3, 30
    ' 41, 42, 43, 44, 45,     0, 48, 49, 40

    Private Const KeyA As Integer = 10
    Private Const KeyB As Integer = 11
    Private Const KeyC As Integer = 12
    Private Const KeyD As Integer = 13
    Private Const KeyE As Integer = 14
    Private Const KeyF As Integer = 15
    Private Const Key7 As Integer = 7
    Private Const Key8 As Integer = 8
    Private Const Key9 As Integer = 9
    Private Const KeyDiv As Integer = 16
    Private Const KeyGSB As Integer = 33
    Private Const KeyGTO As Integer = 34
    Private Const KeyHEX As Integer = 35
    Private Const KeyDEC As Integer = 36
    Private Const KeyOCT As Integer = 37
    Private Const KeyBIN As Integer = 38
    Private Const Key4 As Integer = 4
    Private Const Key5 As Integer = 5
    Private Const Key6 As Integer = 6
    Private Const KeyMul As Integer = 32
    Private Const KeyRS As Integer = 49
    Private Const KeySST As Integer = 50
    Private Const KeyRol As Integer = 51
    Private Const KeyXY As Integer = 52
    Private Const KeyBSP As Integer = 53
    Private Const KeyEnt As Integer = 54
    Private Const Key1 As Integer = 1
    Private Const Key2 As Integer = 2
    Private Const Key3 As Integer = 3
    Private Const KeyMin As Integer = 48
    Private Const KeyON As Integer = 65
    Private Const KeyFKey As Integer = 66
    Private Const KeyGKey As Integer = 67
    Private Const KeySTO As Integer = 68
    Private Const KeyRCL As Integer = 69
    Private Const Key0 As Integer = 0
    Private Const KeyDp As Integer = 72
    Private Const KeyCHS As Integer = 73
    Private Const KeyAdd As Integer = 64

    Public Sub New()
        MyBase.New
        cs = New CalcState
        c = New Calculator(cs)
        p = New Prgm(cs, c)
    End Sub

    <TestMethod()>
    Public Sub row4Yellow()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-16-1000", dp.AlternateText)

        c.ProcessKey(1)
        c.ProcessKey(5)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-15-1000", dp.AlternateText)

        c.ProcessKey(6)
        c.ProcessKey(2)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-62-1000", dp.AlternateText)

        c.ProcessKey(6)
        c.ProcessKey(4)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-64-1000", dp.AlternateText)

        c.ProcessKey(0)        ' special case for "escape clause"
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-64-1000", dp.AlternateText)

        ' My technique for doing scientific notation is a lot different

        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeyRCL)
        c.ProcessKey(3)        ' now in float mode (with 3 decimal places)

        c.ProcessKey(2)
        dp = c.ProcessKey(KeyEnt)
        Assert.AreEqual("2.000", dp.DisplayText)
        c.ProcessKey(4)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyCHS)
        Assert.AreEqual("4e", dp.DisplayText)
        dp = c.ProcessKey(3)
        Assert.AreEqual("4e3", dp.DisplayText)
        dp = c.ProcessKey(KeyEnt)
        Assert.AreEqual("4000.000", dp.DisplayText)

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-16-1000", dp.AlternateText)

        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyAdd)   ' OR
        Assert.AreEqual("7 d", dp.DisplayText)
    End Sub

    <TestMethod()>
    Public Sub row4Blue()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-16-1000", dp.AlternateText)

        ' 16 bit word size
        c.ProcessKey(6)
        c.ProcessKey(4)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)
        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-64-1000", dp.AlternateText)

        c.ProcessKey(2)
        ' 2 billion
        Dim i As Integer
        For i = 0 To 8
            c.ProcessKey(0)
        Next

        c.ProcessKey(KeyEnt)
        c.ProcessKey(4)
        c.ProcessKey(0)
        c.ProcessKey(0)        ' 4 hundred
        dp = c.ProcessKey(KeyMul)   ' Mul
        Assert.AreEqual("800000000000 d", dp.DisplayText)
        dp = c.ProcessKey(KeyBIN)
        Assert.AreEqual("01000011 10110111 01000000 00000000 .b", dp.DisplayText)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeySTO)   ' Scroll <
        Assert.AreEqual("01000011 10110111 01000000 00000000 .b", dp.DisplayText)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyRCL)   ' Scroll >
        Assert.AreEqual(" 01000011 10110111 01000000 0000000 .b.", dp.DisplayText)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyRCL)   ' Scroll >
        Assert.AreEqual("0 01000011 10110111 01000000 000000 .b.", dp.DisplayText)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeySTO)   ' Scroll <
        Assert.AreEqual(" 01000011 10110111 01000000 0000000 .b.", dp.DisplayText)

        ' decimal mode
        c.ProcessKey(KeyDEC)
        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)

        c.ProcessKey(KeyFKey)
        dp = c.ProcessKey(KeyDp)    ' Status
        Assert.AreEqual("1-16-1000", dp.AlternateText)

        c.ProcessKey(0)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(0)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(0)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(0)
        c.ProcessKey(KeyEnt)        ' clear the stack
        c.ProcessKey(4)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(3)
        c.ProcessKey(KeyMul)         ' 12
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyEnt)    ' LSTx
        Assert.AreEqual("3 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("12 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("0 d", dp.DisplayText)
        dp = c.ProcessKey(KeyRol)
        Assert.AreEqual("0 d", dp.DisplayText)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key0) ' x!=y
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key0) ' x!=y
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(0)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(Key0) ' x!=y
        Assert.AreEqual(5, cs.PrgmPosition)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDp)    ' x!=0
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDp)    ' x!=0
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(0)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyDp)    ' x!=0
        Assert.AreEqual(6, cs.PrgmPosition)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyCHS)   ' x=y
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyCHS)   ' x=y
        Assert.AreEqual(5, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(0)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyCHS)   ' x=y
        Assert.AreEqual(6, cs.PrgmPosition)

        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyAdd)   ' x=0
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(5)
        c.ProcessKey(KeyCHS)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyAdd)   ' x=0
        Assert.AreEqual(6, cs.PrgmPosition)
        cs.PrgmPosition = 5
        c.ProcessKey(0)
        c.ProcessKey(KeyGKey)
        dp = c.ProcessKey(KeyAdd)   ' x=0
        Assert.AreEqual(5, cs.PrgmPosition)
    End Sub

    <TestMethod()>
    Public Sub row4White()
        Dim dp As DisplayPacket

        ' decimal mode
        c.ProcessKey(KeyDEC)

        ' 16 bit word size
        c.ProcessKey(1)
        c.ProcessKey(6)
        c.ProcessKey(KeyFKey)
        c.ProcessKey(KeySTO)

        ' 1's complement mode
        c.ProcessKey(KeyFKey)
        c.ProcessKey(1)

        ' I think this is already adequately covered...
        c.ProcessKey(KeyEnt)
        c.ProcessKey(5)
        c.ProcessKey(KeyEnt)
        c.ProcessKey(6)
        dp = c.ProcessKey(KeyAdd)   ' Add
        Assert.AreEqual("11 d", dp.DisplayText)
    End Sub
End Class